precision highp float;
varying  vec2 textureCoordinate;

uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;

uniform  float strength;
uniform  float warp;

void main() {
    vec2 uv = textureCoordinate;
    vec4 tempPixel = texture2D(inputImageTexture2, uv);
    vec4 srcPixel = texture2D(inputImageTexture, uv);
    float lumSrc = (srcPixel.r + srcPixel.g + srcPixel.b) / 3.;
    float lum = (tempPixel.r + tempPixel.g  + tempPixel.b) / 3.;

    highp mat2 rotationMatrix = mat2( cos( 90. ), -sin( 90. ), sin( 90. ),  cos( 90. ));

    float scale = (1. - pow(abs(lum * 10.), 0.8));
    uv += rotationMatrix * (strength * lum * scale * uv/ (1. + warp));
    vec3 col = texture2D(inputImageTexture, uv).rgb;
    col += strength * col * scale / (1. + warp);

    gl_FragColor = vec4(col, 1.0);

}