uniform sampler2D inputImageTexture;
const lowp int GAUSSIAN_SAMPLES = 9;
varying highp vec2 textureCoordinate;
varying highp vec2 blurCoordinates[GAUSSIAN_SAMPLES];
void main()
{
    lowp vec3 sum = vec3(0.0);
    lowp vec4 fragColor=texture2D(inputImageTexture, textureCoordinate);

    vec4 c0 = texture2D(inputImageTexture, blurCoordinates[0]);
    float w0 = c0.a * 0.05;

    vec4 c1 = texture2D(inputImageTexture, blurCoordinates[1]);
    float w1 = c1.a * 0.09;

    vec4 c2 = texture2D(inputImageTexture, blurCoordinates[2]);
    float w2 = c2.a * 0.12;

    vec4 c3 = texture2D(inputImageTexture, blurCoordinates[3]);
    float w3 = c3.a * 0.15;

    vec4 c4 = texture2D(inputImageTexture, blurCoordinates[4]);
    float w4 = c4.a * 0.18;

    vec4 c5 = texture2D(inputImageTexture, blurCoordinates[5]);
    float w5 = c5.a * 0.15;

    vec4 c6 = texture2D(inputImageTexture, blurCoordinates[6]);
    float w6 = c6.a * 0.12;

    vec4 c7 = texture2D(inputImageTexture, blurCoordinates[7]);
    float w7 = c7.a * 0.09;

    vec4 c8 = texture2D(inputImageTexture, blurCoordinates[8]);
    float w8 = c8.a * 0.05;

    float totalWeight = w0 + w1 + w2 + w3 + w4 + w5 + w6 + w7 + w8;
    w0 /= totalWeight;
    w1 /= totalWeight;
    w2 /= totalWeight;
    w3 /= totalWeight;
    w4 /= totalWeight;
    w5 /= totalWeight;
    w6 /= totalWeight;
    w7 /= totalWeight;
    w8 /= totalWeight;

    sum = (c0 * w0 + c1 * w1 + c2 * w2 + c3 * w3 + c4 * w4 + c5 * w5 + c6 * w6 + c7 * w7 + c8 * w8).rgb;

    gl_FragColor = vec4(sum, fragColor.a);
}